/*
GPS Hodiny

verze 1.0

SakulWORLD - http://www.sakul.cz
 
 */

#include <EEPROM.h>
#include <SoftwareSerial.h>

                                          
 SoftwareSerial DispSerial(3, 4);          
 
unsigned long cislo;                      
String inputString = "";                  
int adresa=0;                             

boolean zacatek = false;                  
boolean G = false;                        
boolean P = false;
boolean R = false;
boolean M = false;
boolean C = false;
boolean konec = false;                    
boolean carka = false;                    
char inData;                              
char prevod[7];                           
unsigned long casUTC;                     
unsigned long casSEC;                     
int LetoZima = 20000;                     
byte byte1LetoZima = 0;                   
byte byte2LetoZima = 0;
 
int Tlac = 2;                             
int DvojTecky = 6;                        
int Jumper = 5;                           
int TlacState = 0;                        
boolean pTlac = false;                    
int JumperState = 0;                      
int digit1 = 19;                          
int digit2 = 18; 
int digit3 = 17; 
int digit4 = 16; 
int digit5 = 15; 
int digit6 = 14; 

int segA = 7;                             
int segB = 8; 
int segC = 9; 
int segD = 10; 
int segE = 11; 
int segF = 12; 
int segG = 13; 

void setup() {
  Serial.begin(9600);                                  // Nastavení komunikační rychlosti pro GPS
  DispSerial.begin(19200);
  inputString.reserve(200);
    
  byte1LetoZima = EEPROM.read(adresa);               
  byte2LetoZima = EEPROM.read(adresa + 1); 
  adresa = 0;                                        
  if (byte2LetoZima != 255){                         
  LetoZima = byte1LetoZima + (byte2LetoZima << 8);   
 } 
  
  pinMode(segA, OUTPUT);                             
  pinMode(segB, OUTPUT);
  pinMode(segC, OUTPUT);
  pinMode(segD, OUTPUT);
  pinMode(segE, OUTPUT);
  pinMode(segF, OUTPUT);
  pinMode(segG, OUTPUT);

  pinMode(digit1, OUTPUT);
  pinMode(digit2, OUTPUT);
  pinMode(digit3, OUTPUT);
  pinMode(digit4, OUTPUT);
  pinMode(digit5, OUTPUT);
  pinMode(digit6, OUTPUT);
  
  pinMode(DvojTecky, OUTPUT);
  pinMode(Tlac, INPUT_PULLUP);
  pinMode(Jumper, INPUT_PULLUP);
  
  digitalWrite(DvojTecky,HIGH);
  
}

// ::::::::::::::::::::::::::::::::::: HLAVNÍ PROGRAM ::::::::::::::::::::::::::::::::::::::::::::::::::::

void loop() {
  
  zapisDoEEPROM();                           
  prevodCasu();                               
  displayNumber();                           
  NaDisplay();                               
  
}

// ::::::::::::::::::::::::::::::::::: PODPROGRAMY ::::::::::::::::::::::::::::::::::::::::::::::::::::

void displayNumber() {
unsigned long toDisplay = cislo;            

#define DISPLAY_BRIGHTNESS  900             

#define DIGIT_ON  LOW                      
#define DIGIT_OFF  HIGH

  long beginTime = millis();

  for(int digit = 6 ; digit > 0 ; digit--) {

    
    switch(digit) {
    case 1:
      digitalWrite(digit1, DIGIT_ON);
      break;
    case 2:
      digitalWrite(digit2, DIGIT_ON);
      break;
    case 3:
      digitalWrite(digit3, DIGIT_ON);
      break;
    case 4:
      digitalWrite(digit4, DIGIT_ON);
      break;
    case 5: 
      digitalWrite(digit5, DIGIT_ON);
      break;
    case 6:
      digitalWrite(digit6, DIGIT_ON);
      break;
    }

    
    lightNumber(toDisplay % 10);
    toDisplay /= 10;

    delayMicroseconds(DISPLAY_BRIGHTNESS); 
    

    
    lightNumber(10); 

    
    digitalWrite(digit1, DIGIT_OFF);
    digitalWrite(digit2, DIGIT_OFF);
    digitalWrite(digit3, DIGIT_OFF);
    digitalWrite(digit4, DIGIT_OFF);
    digitalWrite(digit5, DIGIT_OFF);
    digitalWrite(digit6, DIGIT_OFF);
  }

  while( (millis() - beginTime) < 10) ; 
  
}



void lightNumber(int numberToDisplay) {         

#define SEGMENT_ON  LOW                         
#define SEGMENT_OFF HIGH

  switch (numberToDisplay){

  case 0:
    digitalWrite(segA, SEGMENT_ON);
    digitalWrite(segB, SEGMENT_ON);
    digitalWrite(segC, SEGMENT_ON);
    digitalWrite(segD, SEGMENT_ON);
    digitalWrite(segE, SEGMENT_ON);
    digitalWrite(segF, SEGMENT_ON);
    digitalWrite(segG, SEGMENT_OFF);
    break;

  case 1:
    digitalWrite(segA, SEGMENT_OFF);
    digitalWrite(segB, SEGMENT_ON);
    digitalWrite(segC, SEGMENT_ON);
    digitalWrite(segD, SEGMENT_OFF);
    digitalWrite(segE, SEGMENT_OFF);
    digitalWrite(segF, SEGMENT_OFF);
    digitalWrite(segG, SEGMENT_OFF);
    break;

  case 2:
    digitalWrite(segA, SEGMENT_ON);
    digitalWrite(segB, SEGMENT_ON);
    digitalWrite(segC, SEGMENT_OFF);
    digitalWrite(segD, SEGMENT_ON);
    digitalWrite(segE, SEGMENT_ON);
    digitalWrite(segF, SEGMENT_OFF);
    digitalWrite(segG, SEGMENT_ON);
    break;

  case 3:
    digitalWrite(segA, SEGMENT_ON);
    digitalWrite(segB, SEGMENT_ON);
    digitalWrite(segC, SEGMENT_ON);
    digitalWrite(segD, SEGMENT_ON);
    digitalWrite(segE, SEGMENT_OFF);
    digitalWrite(segF, SEGMENT_OFF);
    digitalWrite(segG, SEGMENT_ON);
    break;

  case 4:
    digitalWrite(segA, SEGMENT_OFF);
    digitalWrite(segB, SEGMENT_ON);
    digitalWrite(segC, SEGMENT_ON);
    digitalWrite(segD, SEGMENT_OFF);
    digitalWrite(segE, SEGMENT_OFF);
    digitalWrite(segF, SEGMENT_ON);
    digitalWrite(segG, SEGMENT_ON);
    break;

  case 5:
    digitalWrite(segA, SEGMENT_ON);
    digitalWrite(segB, SEGMENT_OFF);
    digitalWrite(segC, SEGMENT_ON);
    digitalWrite(segD, SEGMENT_ON);
    digitalWrite(segE, SEGMENT_OFF);
    digitalWrite(segF, SEGMENT_ON);
    digitalWrite(segG, SEGMENT_ON);
    break;

  case 6:
    digitalWrite(segA, SEGMENT_ON);
    digitalWrite(segB, SEGMENT_OFF);
    digitalWrite(segC, SEGMENT_ON);
    digitalWrite(segD, SEGMENT_ON);
    digitalWrite(segE, SEGMENT_ON);
    digitalWrite(segF, SEGMENT_ON);
    digitalWrite(segG, SEGMENT_ON);
    break;

  case 7:
    digitalWrite(segA, SEGMENT_ON);
    digitalWrite(segB, SEGMENT_ON);
    digitalWrite(segC, SEGMENT_ON);
    digitalWrite(segD, SEGMENT_OFF);
    digitalWrite(segE, SEGMENT_OFF);
    digitalWrite(segF, SEGMENT_OFF);
    digitalWrite(segG, SEGMENT_OFF);
    break;

  case 8:                                         // 
    digitalWrite(segA, SEGMENT_ON);
    digitalWrite(segB, SEGMENT_ON);
    digitalWrite(segC, SEGMENT_ON);
    digitalWrite(segD, SEGMENT_ON);
    digitalWrite(segE, SEGMENT_ON);
    digitalWrite(segF, SEGMENT_ON);
    digitalWrite(segG, SEGMENT_ON);
    break;

  case 9:                                         // 
    digitalWrite(segA, SEGMENT_ON);
    digitalWrite(segB, SEGMENT_ON);
    digitalWrite(segC, SEGMENT_ON);
    digitalWrite(segD, SEGMENT_ON);
    digitalWrite(segE, SEGMENT_OFF);
    digitalWrite(segF, SEGMENT_ON);
    digitalWrite(segG, SEGMENT_ON);
    break;

  case 10:                                       // 
    digitalWrite(segA, SEGMENT_OFF);
    digitalWrite(segB, SEGMENT_OFF);
    digitalWrite(segC, SEGMENT_OFF);
    digitalWrite(segD, SEGMENT_OFF);
    digitalWrite(segE, SEGMENT_OFF);
    digitalWrite(segF, SEGMENT_OFF);
    digitalWrite(segG, SEGMENT_OFF);
    break;
  }
}

void serialEvent() {                             
  if (Serial.available()) {                      
  inData = (char)Serial.read();                  
   if (inData == '$') {                          
   zacatek = true;                               
   inputString = ""; 
  }
  if (zacatek == true){                                  
   if (inData == 'G') {                      
   G = true;
   inputString = "";   
   }
   if (G == true){                 
    if (inData == 'P') {                       
    P = true;
    inputString = "";    
    }
    if (P == true){                 
     if (inData == 'R') {                       
     R = true;
     inputString = "";     
     }
     if (R == true){                 
      if (inData == 'M') {                       
      M = true;
      inputString = "";      
      }
      if (M == true){                 
       if (inData == 'C') {                       
       C = true;
       inputString = "";       
       }
       if (C == true){                 
        if (inData == ',') {                       
        konec = true;                                 
        inputString = "";
       }
      }
     }
    }
   }
  }
 }
  if (konec == true) {                               
    if (inData != ',') {                             
      if (inData != '.') {                           
       inputString += inData;                        
       }
    if (inData == '.') {                                
        inputString.toCharArray(prevod,7);           
        casUTC = atol(prevod);                       
        inputString = "";                            
        zacatek = false;                             
        G = false;
        P = false;
        R = false;
        M = false;
        C = false;
        konec = false;
       }
      }     
     }
 }      
}

void prevodCasu() {                                  
    casSEC=casUTC + LetoZima;                        
    if (casSEC >= 240000) {                          
      casSEC=(casSEC - 240000);
     }
     
    cislo=casSEC;                                       
}

void zapisDoEEPROM() {                               
  TlacState = digitalRead(Tlac);                     
  if (TlacState== false){
    if (pTlac==false){
        pTlac=true;
      if (LetoZima == 20000){                        
          LetoZima = 10000;                          
          }
          else {LetoZima=20000;}                     
    
    byte1LetoZima = LetoZima;                       
    byte2LetoZima = LetoZima >> 8;
    EEPROM.write(adresa, byte1LetoZima);             
    EEPROM.write(adresa + 1, byte2LetoZima);
    adresa = 0;                                     
  }
 }
 else {pTlac=false;}    
}

void NaDisplay() {                                   
                                                      
     byte Sekundy;                                   
     byte DeSekund;                                  
     byte Minuty;                                   
     byte DeMinut;                                   
     byte Hodiny;                                    
     byte DeHodin;                                   
                                                    
     byte sSekundy;                
     byte sDeSekund;
     byte sMinuty;
     byte sDeMinut;
     byte sHodiny;
     byte sDeHodin;
   
     Sekundy = (casSEC %10);                         
     DeSekund = (casSEC %100 /10);                   
     Minuty = (casSEC %1000 /100);                   
     DeMinut = (casSEC %10000 /1000);                
     Hodiny = (casSEC %100000 /10000);               
     DeHodin = (casSEC %1000000 /100000);            
                                                    
     byte odeslat;                                   
     sSekundy = (Sekundy +1  << 4);                  
     odeslat = sSekundy +1;                          
     DispSerial.write(odeslat);                     
     Serial.print(Sekundy);
       
     sDeSekund = (DeSekund +1  << 4);
     odeslat = sDeSekund +2;
     DispSerial.write(odeslat);
     Serial.print(DeSekund);
       
     sMinuty = (Minuty +1  << 4);
     odeslat = sMinuty +3;
     DispSerial.write(odeslat);
     Serial.print(Minuty);
         
     sDeMinut = (DeMinut +1  << 4);
     odeslat = sDeMinut +4;
     DispSerial.write(odeslat);
     Serial.print(DeMinut);
      
     sHodiny = (Hodiny +1  << 4);
     odeslat = sHodiny +5;
     DispSerial.write(odeslat);
     Serial.print(Hodiny);
       
     sDeHodin = (DeHodin +1  << 4);
     odeslat = sDeHodin +6;
     DispSerial.write(odeslat);
     Serial.print(DeHodin);
     
     byte dvojteckaON = 240;                         
     byte dvojteckaOFF = 0;                          
     
     if (Sekundy <= 5){                              
       DispSerial.write(dvojteckaON);
      }
       else {DispSerial.write(dvojteckaOFF);}
}
